#ifndef MAIN_H
#define MAIN_H
/*
* Dateiname.... main.h
* erstellt am.. 2016-10-30
* gendert am.. 2016-10-30
* Autor........ Clemens B Fahr
* email........ clemens.fahr[at]fahrnet.de
* Kommentar.... based on RFM_wireless_4CH_sensor_02_mod
* .............	
* .............				
*/

// includes
//------------------------------------------------------------------
#include <avr/io.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <stdlib.h>
#include <avr/sleep.h>

// defines
//------------------------------------------------------------------

// variables
//------------------------------------------------------------------
uint8_t DEVICE_ID1 EEMEM = 0xCC;
uint8_t DEVICE_ID2 EEMEM = 0x11;
uint8_t DEVICE_UID1 EEMEM = 0x10;
uint8_t DEVICE_UID2 EEMEM = 0x02;

extern volatile uint8_t TX_buffer[];
extern volatile uint16_t ADC_previous_value[MAX_ADC_BUFFER];
extern volatile uint8_t ADC_TX_holdoff[MAX_ADC_BUFFER];
extern volatile uint8_t telegram_length;
extern volatile uint16_t status_flag;
extern volatile uint8_t ADC_change;
extern volatile uint8_t global_TX_holdoff;

// forward and external declarations
//------------------------------------------------------------------
extern void LOWLEVEL_init_all(void);
extern void LOWLEVEL_init_RFM(void);
extern void LOWLEVEL_init_ADC_buffer(uint8_t numba_bytes);
extern void LOWLEVEL_sleep_RFM(uint16_t sleep_time);
extern void LOWLEVEL_send_telegram_RFM(uint8_t NumbaDataBytes);
extern uint16_t LOWLEVEL_status_register_read(void);
extern void LOWLEVEL_delay_1ms(uint16_t multiplier);
extern void LOWLEVEL_blink_status_LED(uint8_t numba_blink);
extern uint16_t LOWLEVEL_adcConvert(uint8_t ADC_channel, uint8_t reference_voltage);
extern void LOWLEVEL_debugOut(uint8_t aByte);
uint8_t MAIN_buildMessage(void);
uint8_t MAIN_tresholdExceed(uint16_t current_value, uint8_t elem, uint8_t threshold_value, uint8_t TX_holdoff);

#endif